Module Functions
    Dim enc As New System.Text.ASCIIEncoding
    Dim s As String
    Dim s1 As String
    Public Function StringHereToHere(ByVal here As String, ByVal here1 As String, ByVal here2 As String) As String
        StringHereToHere = here.Substring(here.IndexOf(here1) + here1.Length, here.IndexOf(here2, here.IndexOf(here1) + here1.Length) - here.IndexOf(here1) - here1.Length)
    End Function
    Public Function StringEndToEnd(ByVal here As String, ByVal here1 As String, ByVal here2 As String) As String
        StringEndToEnd = here.Substring(here.LastIndexOf(here1) + here1.Length, here.LastIndexOf(here2) - here.LastIndexOf(here1) - here1.Length)
    End Function
    Public Function PathEt(ByVal str As String) As String
        Return Replace(str & "\", "\\", "\")
    End Function
    Public Function HexString(ByVal b() As Byte, ByVal l As Integer, ByVal offset As Integer) As String
        Dim i As Integer
        If l = 0 Then l = b.Length
        Dim str As String = ""
        For i = offset To l - 1 + offset
            str = str & " " & Hex(b(i))
        Next
        Return str
    End Function
    Public Sub InitiateSession(ByVal sd As Net.Sockets.Socket, ByVal base As String)
        Dim Command As String = "NSPlayer/9.0.0.2980; {" & Guid.NewGuid.ToString & "}; Host: " & base
        Dim P1B1 As Byte() = {&HF0, &HF0, &HF0, &HF0, &HB, &H0, &H4, &H0, &H1C, &H0, &H3, &H0}
        Dim P1B2 As Byte() = Pad0(enc.GetBytes(Command), 6)
        sd.Send(HPacket(&H1, P1B1, P1B2))
    End Sub
    Public Sub SendTimingTest(ByVal sd As Net.Sockets.Socket)
        Dim P2B1 As Byte() = {&HF1, &HF0, &HF0, &HF0, &HB, &H0, &H4, &H0}
        sd.Send(HPacket(&H18, P2B1, Nothing))
    End Sub
    Public Sub RequestConnection(ByVal sd As Net.Sockets.Socket)
        Dim Command3 As String = "\\" & Replace(sd.LocalEndPoint.ToString, ":", "\TCP\")
        Command3 = "\\" & StringHereToHere(Command3, "\\", "\TCP\") & "\TCP\1755"
        Dim P3B1 As Byte() = {&HF1, &HF0, &HF0, &HF0, &HFF, &HFF, &HFF, &HFF, &H0, &H0, &H0, &H0, &H0, &H0, &HA0, &H0, &H2, &H0, &H0, &H0}
        Dim P3B2 As Byte() = Pad0(enc.GetBytes(Command3), 2)
        sd.Send(HPacket(&H2, P3B1, P3B2))
    End Sub
    Public Sub RequestFile(ByVal sd As Net.Sockets.Socket, ByVal rest As String)
        Dim P4B1 As Byte() = {&H1, &H0, &H0, &H0, &HFF, &HFF, &HFF, &HFF, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0}
        Dim P4B2 As Byte() = Pad0(enc.GetBytes(rest), 0)
        sd.Send(HPacket(&H5, P4B1, P4B2))
    End Sub
    Public Sub MMSDownload(ByVal Url As String, ByVal Status As Object, ByVal path As String, ByVal Info As Object)
        Dim two As Boolean = False
again:  Dim base As String
        Dim rest As String
        Dim enc As New System.Text.ASCIIEncoding
        base = Replace(Url, "mms://", "")
        base = base.Substring(0, base.IndexOf("/"))
        rest = Replace(Url, "mms://" & base & "/", "")
        rest = Replace(rest, " ", "%20")
        Status.Text = "Resolving IP address..."
        Dim sd As New Net.Sockets.Socket(Net.Sockets.AddressFamily.InterNetwork, Net.Sockets.SocketType.Stream, Net.Sockets.ProtocolType.Tcp)
        Dim dip As New Net.IPEndPoint(Net.Dns.GetHostEntry(base).AddressList(0), 1755)
        Status.Text = "Connecting..."
        sd.Connect(dip)
        Status.Text = "Connected."
        Status.Text = "Initializing Session..."
        InitiateSession(sd, base)
        CommandCheck(sd, &H1, Status)
        Status.Text = "Session Established. Sending 1st Network Timing Test..."
        SendTimingTest(sd)
        CommandCheck(sd, &H15, Status)
        Status.Text = "Session Established. Sending 2nd Network Timing Test..."
        SendTimingTest(sd)
        CommandCheck(sd, &H15, Status)
        Status.Text = "Session Established. Sending 3rd Network Timing Test..."
        SendTimingTest(sd)
        CommandCheck(sd, &H15, Status)
        Status.Text = "Network Timing Test Successful. Requesting TCP Connection..."
        RequestConnection(sd)
        CommandCheck(sd, &H2, Status)
        Status.Text = "TCP Connection Accepted. Requesting File " & rest
        RequestFile(sd, rest)
        Dim b() As Byte = CommandCheck(sd, &H6, Status)
        Status.text = "File Request Accepted."
        Dim t As String = HexM(b(71)) & HexM(b(70)) & HexM(b(69)) & HexM(b(68)) & HexM(b(67)) & HexM(b(66)) & HexM(b(65)) & HexM(b(64))
        Dim psize As Integer = b(92) + b(93) * 256 + b(94) * 4096
        Dim nps As Integer = b(96) + b(97) * 256 + b(98) * 4096
        Dim hsize As Integer = b(108) + b(109) * 256 + b(110) * 4096
        Dim fsize As Integer = psize * nps + hsize
        Dim time As Decimal = (DoublePercisionHex(t) - 3.6)
        Info.text = "File Size: " & fsize & "Bytes" & vbCrLf & "Media Length: " & time & "Seconds" & vbCrLf & "Packet Size: " & psize & "Bytes" & vbCrLf & "Header Size: " & hsize & "Bytes" & vbCrLf & "Number of Packets: " & nps & "Packets"
        WriteStream(sd, Status, path, time, hsize)
        Status.Text = "Done!"
    End Sub
    Public Sub HTTPMMSDownload(ByVal Url As String, ByVal Status As Object, ByVal path As String, ByVal Info As Object)
        Dim base As String
        base = Replace(Url, "mms://", "")
        base = Strings.Left(base, InStr(base, "/") - 1)
        Dim s As New Net.Sockets.Socket(Net.Sockets.AddressFamily.InterNetwork, Net.Sockets.SocketType.Stream, Net.Sockets.ProtocolType.Tcp)
        Dim ip As New Net.IPEndPoint(Net.Dns.GetHostEntry(base).AddressList(0), "80")
        Status.text = "Connecting..."
        s.Connect(ip)
        Status.text = "Connected. Sending Get Request..."
        Dim getfile As String
        getfile = Replace(Url, "mms://" & base, "")
        Dim enc As New System.Text.ASCIIEncoding
        getfile = "GET " & getfile & " HTTP/1.1" & vbCrLf & "Accept: */*" & vbCrLf & "User-Agent: NSPlayer/9.0.0.2980" & vbCrLf & "Host: " & base & vbCrLf & "Pragma: no-cache,rate=1.000000,stream-time=0" & vbCrLf & "Pragma: xPlayStrm=1" & vbCrLf & "Pragma: xClientGUID={" & Guid.NewGuid.ToString() & "}" & vbCrLf & vbCrLf
        Dim bytes As Byte() = enc.GetBytes(getfile)
        s.Send(bytes, bytes.Length, Net.Sockets.SocketFlags.None)
        Dim n As Integer = 0
        Dim recbytes(1023) As Byte
        Dim hinfo As String = ""
        Dim rbytes As Integer = 0
        Status.Text = "Recieving Command Header..."
        Do
            n = s.Receive(recbytes, 1, Net.Sockets.SocketFlags.None)
            rbytes = rbytes + n
            hinfo = hinfo & enc.GetString(recbytes, 0, n)
            Status.Text = "Recieving Command Header..." & rbytes & "Bytes Recieved..."
            If hinfo.Contains(vbCrLf & vbCrLf) = True Then Exit Do
        Loop
        Dim tbytes(10000) As Byte
        If hinfo.Contains("Busy") = True Then Status.Text = "Session Not Ready." & vbCrLf & "Retry in 10 seconds..." : Exit Sub
        Status.Text = "Header Recieved...Recieving Data..."
        Dim i As Integer
        Dim n1 As Integer
        Dim cur As Integer
        Dim fs As New IO.FileStream(path, IO.FileMode.Create)
        Dim bs(7) As Byte
        Dim p As Integer
        Dim np As Integer
        Dim rp As Integer
        Dim y As New Guid("75B22630-668E-11CF-A6D9-00AA0062CE6C")
        n1 = 0
        Do
            n = s.Receive(tbytes, n1, 16, Net.Sockets.SocketFlags.None)
            n1 = n1 + n
            Status.Text = "Sorting Header..." & n1 & "Bytes Recieved..."
        Loop Until Find(y.ToByteArray, tbytes) > 0
        Dim x() As Array = SortOutHeader(tbytes, n1)
        fs.Write(x(0), 0, x(0).Length)
        bs = x(1)
        hinfo = HexString(bs, 0, 0)
        i = bs(6) + bs(7) * (256) - 8 - x(0).Length
        cur = cur + i + x(0).Length
more:   Status.text = "Header Size: " & cur & "Bytes"
        Dim header(i - 1) As Byte
        n1 = 0
        Do Until n1 = i
            n = s.Receive(header, n1, i - n1, 0)
            n1 = n1 + n
        Loop
        If p = 0 Then p = GetPacketLength(header)
        If np = 0 Then np = GetNumberOfPackets(header)
        fs.Write(header, 0, header.Length)
        If bs(5) = &H4 Or bs(5) = &H8 Then
            n1 = 0
            Do Until n1 = 8
                n = s.Receive(bs, n1, 8 - n1, 0)
                n1 = n1 + n
            Loop
            hinfo = HexString(bs, 0, 0)
            i = bs(6) + bs(7) * (256) - 8
            cur = cur + i
            GoTo more
        End If
        ReDim bs(11)
        n1 = 0
        Do Until n1 = 12
            n = s.Receive(bs, n1, 12 - n1, 0)
            n1 = n1 + n
        Loop
        i = bs(10) + bs(11) * (256) - 8
        rp = 0
        Do
            rp = rp + 1
            Dim buffer(p - 1) As Byte
            n1 = 0
            Do Until n1 = i
                n = s.Receive(buffer, n1, i - n1, 0)
                n1 = n1 + n
            Loop
            fs.Write(buffer, 0, p)
            cur = cur + p
            Status.text = "Recieving Packets. Packet Size Is " & p & "." & vbCrLf & "Recieved " & rp & " Packets Out Of " & np & "." & vbCrLf & "Downloaded So Far " & cur & "Bytes."
            n1 = 0
            Do Until n1 = 12
                n = s.Receive(bs, n1, 12 - n1, 0)
                n1 = n1 + n
            Loop
            'MsgBox(HexString(bs, 0, 0))
            'MsgBox(Convert(bs))
            i = bs(10) + bs(11) * (256) - 8
            'MsgBox(i)
            'n1 = 0
            'Do Until n1 = 8
            '    n = s.Receive(bs, n1, 8 - n1, 0)
            '    n1 = n1 + n
            'Loop
            'MsgBox(HexString(bs, 0, 0))
        Loop Until n = 0
        n = s.Receive(bs, 1, 0)
        If n > 0 Then MsgBox("MORE!")
    End Sub
    Public Sub WriteStream(ByVal sd As Net.Sockets.Socket, ByVal status As Object, ByVal path As String, ByVal time As Decimal, ByVal hsize As Integer)
        Dim p As Integer = 0
        Dim np As Integer = 0
        Dim rp As Integer = 0
        Dim fs As IO.FileStream
        Dim fe As Boolean = False
        fs = New IO.FileStream(path, IO.FileMode.Create, IO.FileAccess.Write)
        Dim P5B1 As Byte() = {&H1, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H80, &H0, &H0, &HFF, &HFF, &HFF, &HFF, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H20, &HAC, &H40, &H2, &H0, &H0, &H0, &H0, &H0, &H0, &H0}
        Dim rb() As Byte
        If fe = True Then
            ReDim rb(fs.Length - 1)
            fs.Read(rb, 0, rb.Length)
            p = GetPacketLength(rb)
            np = GetNumberOfPackets(rb)
            rp = (fs.Length - hsize) \ p
            Dim rtime As Decimal
            rtime = ((rp) / np) * time
            Dim br() As Byte = HexDoublePercision(rtime)
            Array.ConstrainedCopy(br, 0, P5B1, 8, 8)
        End If
        status.Text = "Requesting Media Header..."
        sd.Send(HPacket(&H15, P5B1, Nothing))
        Dim n As Integer
        Dim n1 As Integer = 0
        Dim bs(7) As Byte
        Dim i As Integer
        Dim cur As Integer = 0
        Dim sp As Integer = 0
        Dim b() As Byte = ReturnB(sd)
        If fe = True Then fs.Position = 0
        If b(36) = &H11 Then
more:       n1 = 0
            Do Until n1 = 8
                n = sd.Receive(bs, n1, 8 - n1, 0)
                n1 = n1 + n
            Loop
            Array.ConstrainedCopy(bs, 0, b, 0, n)
            i = bs(6) + bs(7) * (256) - 8
            s = HexString(bs, 0, 0)
            cur = cur + i
            status.text = "Header Size: " & cur & "Bytes"
            Dim header(i - 1) As Byte
            n1 = 0
            Do Until n1 = i
                n = sd.Receive(header, n1, i - n1, 0)
                n1 = n1 + n
            Loop
            If fe = True Then
                If Find(header, rb) = -1 Then MsgBox("ERROR! Files Dont Match!") ': Exit Sub
            End If
            If p = 0 Then p = GetPacketLength(header)
            If np = 0 Then np = GetNumberOfPackets(header)
            fs.Write(header, 0, header.Length)
            If bs(5) = &H4 Or bs(5) = &H8 Then
                GoTo more
            End If
        End If
        If fe = True Then fs.Position = fs.Length - 1
        status.text = "Header Recieved And Written...Requesting Media..."
        Dim P6B1 As Byte() = {&H1, &H0, &H0, &H0, &HFF, &HFF, &H1, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &HFF, &HFF, &HFF, &HFF, &HFF, &HFF, &HFF, &HFF, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0}
        sd.Send(HPacket(&H7, P6B1, Nothing))
        Dim b2() As Byte = ReturnB(sd)
        cur = 0
        If b2(36) = &H21 Then
            Dim b3() As Byte = ReturnB(sd)
            If b3(36) = &H5 Then
                n1 = 0
                Do Until n1 = 8
                    n = sd.Receive(bs, n1, 8 - n1, 0)
                    n1 = n1 + n
                Loop
                i = bs(6) + bs(7) * (256)
                i = i - 8
                Dim s As String
                s = HexString(bs, 8, 0)
                Dim buffer(p - 1) As Byte
                Do
                    n1 = 0
                    Do Until n1 = i
                        n = sd.Receive(buffer, n1, i - n1, 0)
                        n1 = n1 + n
                    Loop
                    If fe = True Then
                        If Find(buffer, rb) > -1 Then
                            sp = sp + 1
                            MsgBox("skipped: " & sp)
                            GoTo skip
                        Else
                            fe = False
                        End If
                    End If
                    s = HexString(buffer, 0, 0)
                    If s.Contains("1B 0 4 0") = True Then MsgBox("!!!!")
                    fs.Write(buffer, 0, p)
                    cur = cur + p
                    status.text = "Recieving Packets. Packet Size Is " & p & "." & vbCrLf & "Recieved " & rp & " Packets Out Of " & np & "." & vbCrLf & "Downloaded So Far " & cur & "Bytes."
skip:               n1 = 0
                    Dim b1 As Integer = 0
                    Do Until n1 = 8
                        n = sd.Receive(bs, n1, 8 - n1, 0)
                        If n = 0 Then b1 = b1 + 1
                        If b1 > 0 Then status.text = b1
                        n1 = n1 + n
                    Loop
                    s1 = HexString(bs, 0, 0)
                    If s1.Contains("CE FA B B0") = True Then
                        Do
                            Dim x As Integer = ReturnB2(sd)
                            If x = 1 Then status.text = "Download Is Complete!" : Exit Sub
                            If x = 2 Then
                                status.text = "Sending Network Timing Test.."
                                TTTest(sd)
                                n1 = 0
                                Do Until n1 = 8
                                    n = sd.Receive(bs, n1, 8 - n1, 0)
                                    n1 = n1 + n
                                Loop
                            End If
                        Loop Until HexString(bs, 8, 0).Contains("CE FA B B0") = False
                    End If
                    i = bs(6) + bs(7) * (256) - 8
                    rp = rp + 1
                Loop
            End If
        End If
    End Sub
    Public Function HexM(ByVal i As Integer) As String
        Dim str As String = Hex(i)
        If str.Length < 2 Then str = "0" & str
        Return str
    End Function
    Public Function DoublePercisionHex(ByVal str As String) As Decimal
        Dim strFull As String = HexToBinary64BitCalculate(str)
        Dim S As String = strFull.Substring(0, 1)
        Dim E As String = strFull.Substring(1, 11)
        Dim F As String = strFull.Substring(12, 52)
        If S & E & F <> strFull Then MsgBox("Calculation Error!")
        F = "1." & F
        Dim exp As Integer = Int(BinaryCalculate(E)) - 1023
        If exp > 2047 Or exp < 0 Then MsgBox("Calculation Error!")
        Dim d As Decimal = BinaryCalculate(F)
        exp = 2 ^ exp
        Return exp * d
    End Function
    Public Function HexDoublePercision(ByVal d As Decimal) As Byte()
        Dim str As String = ""
        Dim s As String = "0"
        Dim exp As Integer = 0
        Do Until 2 ^ (exp + 1) > d
            exp = exp + 1
        Loop
        Dim e As String = ZM(BinaryConvert(exp + 1023), 11)
        Dim df As Decimal
        df = (d / (2 ^ exp)) - 1
        Dim f As String = BinaryConvert(df)
        f = f.Substring(f.IndexOf(".") + 1, 52)
        str = s & e & f
        Dim hs As String = Hex(BinaryICalculate(str))
        Do Until hs.Length = 16
            hs = "0" & hs
        Loop
        Dim bs(7) As Byte
        bs(0) = Val("&h" & hs.Substring(14, 2))
        bs(1) = Val("&h" & hs.Substring(12, 2))
        bs(2) = Val("&h" & hs.Substring(10, 2))
        bs(3) = Val("&h" & hs.Substring(8, 2))
        bs(4) = Val("&h" & hs.Substring(6, 2))
        bs(5) = Val("&h" & hs.Substring(4, 2))
        bs(6) = Val("&h" & hs.Substring(2, 2))
        bs(7) = Val("&h" & hs.Substring(0, 2))
        Return bs
    End Function
    Private Function HexToBinary64BitCalculate(ByVal str As String) As String
        Dim n As Integer
        Dim r As Int64 = 0
        Dim i As Int64 = 0
        i = CLng("&h" & str)
        Dim out As String = "0"
        n = 63
        Do Until n = 0
            n = n - 1
            r = 2 ^ n
            If i - r >= 0 Then out = out & "1" : i = i - r : Continue Do
            If i - r < 0 Then out = out & "0"
        Loop
        Return out
    End Function
    Private Function BinaryCalculate(ByVal str As String) As Decimal
        Dim i As Decimal = 0
        Dim n As Int64 = 0
        Dim strp As String = str
        Dim strn As String = ""
        If str.Contains(".") Then strp = str.Substring(0, str.IndexOf(".")) : strn = str
        If str.Contains(".") Then strn = strn.Substring(str.IndexOf(".") + 1)
        Do Until strp.Length = 0
            i = i + (strp.Substring(strp.Length - 1) * 2 ^ n)
            n = n + 1
            strp = strp.Substring(0, strp.Length - 1)
        Loop
        n = 0
        Do Until strn.Length = 0
            n = n - 1
            i = i + (strn.Substring(0, 1) * 2 ^ n)
            strn = strn.Substring(1)
        Loop
        Return i
    End Function
    Public Function BinaryICalculate(ByVal str As String) As Int64
        Dim i As Int64 = 0
        Dim n As Integer
        Dim mp As Int64 = 1
        Dim strp As String = str
        For n = str.Length - 1 To 1 Step -1
            If str.Chars(n) = "1" Then i = i + mp
            If n = 1 Then Exit For
            mp = mp * 2
        Next
        Return i
    End Function
    Private Function ZM(ByVal str As String, ByVal n As Integer) As String
        str = str.Substring(0, str.IndexOf("."))
        If str.Length > n Then MsgBox("!!!!111")
        Do Until str.Length = n
            str = "0" & str
        Loop
        Return str
    End Function
    Private Function BinaryConvert(ByVal dec As String) As String
        Dim strp As String = dec
        Dim strn As String = ""
        If dec.Contains(".") Then strp = dec.Substring(0, dec.IndexOf(".")) : strn = dec
        If dec.Contains(".") Then strn = strn.Substring(dec.IndexOf(".") + 1)
        Dim pi As Integer = strp
        Dim ni As Decimal = "0." & strn
        Dim n As Integer = 63
        strp = ""
        strn = "."
        Do
            If 2 ^ n > pi Then n = n - 1 : strp = strp & "0" : Continue Do
            pi = pi - 2 ^ n
            strp = strp & "1"
            n = n - 1
        Loop Until n = -1
        Do Until n = -63
            If 2 ^ n > ni Then n = n - 1 : strn = strn & "0" : Continue Do
            ni = ni - 2 ^ n
            strn = strn & "1"
            n = n - 1
        Loop
        Dim str As String = strp & strn
        Do Until str(0) <> "0"
            str = str.Substring(1)
        Loop
        Return str
    End Function
    Public Function CheckQueryAtOffset(ByVal Query As Byte(), ByVal Pool As Byte(), ByVal PoolOffset As Integer) As Boolean
        Dim b1() As Byte = Query
        Dim b2(b1.Length - 1) As Byte
        Array.ConstrainedCopy(Pool, PoolOffset, b2, 0, b1.Length)
        Dim i As Integer
        For i = 0 To b1.Length - 1
            If b1(i) <> b2(i) Then Return False : Exit Function
        Next
        Return True
    End Function
    Public Function Find(ByVal Query As Byte(), ByVal Pool As Byte()) As Integer
        Dim i As Integer
        For i = 0 To Pool.Length - Query.Length - 1
            If Pool(i) = Query(0) Then
                If CheckQueryAtOffset(Query, Pool, i) = True Then Return i : Exit Function
            End If
        Next
        Return -1
    End Function
    Public Function SortOutHeader(ByVal b() As Byte, ByVal n1 As Integer) As Array()
        Dim x(1) As Array
        Dim y As New Guid("75B22630-668E-11CF-A6D9-00AA0062CE6C")
        Dim pos As Integer = Find(y.ToByteArray, b)
        Dim c(n1 - pos - 1) As Byte
        Array.ConstrainedCopy(b, pos, c, 0, n1 - pos)
        x(0) = c
        Dim bs(7) As Byte
        Array.ConstrainedCopy(b, pos - 8, bs, 0, 8)
        x(1) = bs
        Return x
    End Function
    Public Function GetPacketLength(ByVal header As Byte()) As Integer
        Dim y As New Guid("8CABDCA1-A947-11CF-8EE4-00C00C205365")
        Dim b() As Byte = y.ToByteArray
        Dim i As Integer
        Dim pos As Integer
        For i = 0 To header.Length - 17
            If header(i) = b(0) Then
                If CheckByteArrays(b, header, i) = True Then pos = i : Exit For
            End If
        Next
        pos = pos + 92
        Dim psize As Integer = header(pos) + header(pos + 1) * 256 + header(pos + 2) * 4096
        Return psize
    End Function
    Public Function GetNumberOfPackets(ByVal header As Byte()) As Integer
        Dim y As New Guid("8CABDCA1-A947-11CF-8EE4-00C00C205365")
        Dim b() As Byte = y.ToByteArray
        Dim i As Integer
        Dim pos As Integer
        For i = 0 To header.Length - 17
            If header(i) = b(0) Then
                If CheckByteArrays(b, header, i) = True Then pos = i : Exit For
            End If
        Next
        pos = pos + 56
        Dim npackets As Integer = header(pos) + header(pos + 1) * 256 + header(pos + 2) * 4096
        Return npackets
    End Function
    Public Function CheckByteArrays(ByVal byte1 As Byte(), ByVal byte2() As Byte, ByVal offset2 As Integer) As Boolean
        Dim b1() As Byte = byte1
        Dim b2(b1.Length - 1) As Byte
        Array.ConstrainedCopy(byte2, offset2, b2, 0, b1.Length)
        Dim i As Integer
        For i = 0 To b1.Length - 1
            If b1(i) <> b2(i) Then Return False : Exit Function
        Next
        Return True
    End Function
    Public Function ReturnB(ByVal sd As Net.Sockets.Socket) As Byte()
        Dim n As Integer
        Dim b(10000) As Byte
        Dim bs(7) As Byte
        Dim i As Integer = 0
        Dim n1 As Integer = 0
        Do Until n1 = 8
            n = sd.Receive(bs, n1, 8 - n1, 0)
            n1 = n1 + n
        Loop
        Array.ConstrainedCopy(bs, 0, b, 0, n)
        n1 = 0
        Do Until n1 = 8
            n = sd.Receive(bs, n1, 8 - n1, 0)
            n1 = n1 + n
        Loop
        Array.ConstrainedCopy(bs, 0, b, 8, n)
        i = bs(0) + bs(1) * (256)
        n1 = 0
        Do Until n1 = i
            n = sd.Receive(b, 16 + n1, i - n1, 0)
            n1 = n1 + n
        Loop
        Dim c(16 + i - 1) As Byte
        Array.ConstrainedCopy(b, 0, c, 0, 16 + i)
        Return c
    End Function
    Public Function ReturnB2(ByVal sd As Net.Sockets.Socket) As Integer
        Dim n As Integer
        Dim bs(7) As Byte
        Dim i As Integer = 0
        Dim n1 As Integer = 0
        Do Until n1 = 8
            n = sd.Receive(bs, n1, 8 - n1, 0)
            n1 = n1 + n
        Loop
        i = bs(0) + bs(1) * 256 + bs(2) * 4096 + bs(3) * (16 ^ 4)
        Dim b(i + 8 - 1) As Byte
        Array.ConstrainedCopy(bs, 0, b, 0, n)
        n = sd.Receive(b, 8, i, 0)
        s = HexString(b, 8 + n, 0)
        If s.Contains("1E 0 4 0") Then Return 1
        If s.Contains("1B 0 4 0") Then Return 2
    End Function
    Public Function CommandCheck(ByVal sd As Net.Sockets.Socket, ByVal comm As Integer, ByVal status As Object) As Byte()
        Dim n1 As Integer = 0
        Dim n As Integer
        Dim b(10000) As Byte
        Dim bs(7) As Byte
        Dim i As Integer = 0
        Do Until n1 = 8
            n = sd.Receive(bs, n1, 8 - n1, 0)
            n1 = n1 + n
        Loop
        Array.ConstrainedCopy(bs, 0, b, 0, n)
        n1 = 0
        Do Until n1 = 8
            n = sd.Receive(bs, n1, 8 - n1, 0)
            n1 = n1 + n
        Loop
        Array.ConstrainedCopy(bs, 0, b, 8, n)
        i = bs(0) + bs(1) * (256)
        n1 = 0
        Do Until n1 = i
            n = sd.Receive(b, 16 + n1, i - n1, 0)
            n1 = n1 + n
        Loop
        s = HexString(b, 16 + n, 0)
        If s.Contains("1b 0 4 0") = True Then TTTest(sd) : Return CommandCheck(sd, comm, status) : Exit Function
        If b(36) <> comm Then
            If b(36) = &H1B Then status.text = "Performing Network Timing Test" : TTTest(sd)
            If b(36) = &H15 Then status.text = "Validating Network Connection..." : Return CommandCheck(sd, comm, status) : Exit Function
        End If
        Return b
        If (n > i) = True Then
            MsgBox("")
            Dim z As Integer = 0
            Do Until n = 0
                n = sd.Receive(b, 16 + i + 1 + z, 2, 0)
                z = z + n
            Loop
            s = HexString(b, 16 + i + 1 + n, 0)
            MsgBox(16 + i + 1 + z)
        End If
        If i * 4 < 40 Then
            MsgBox(i)
            Do Until n = 0
                n = sd.Receive(b, 16 + i, i, 0)
                If n > 0 Then MsgBox("HUH?")
            Loop
        End If
    End Function
    Public Function Pad0(ByVal array() As Byte, ByVal extra As Integer) As Byte()
        Dim narray(array.Length * 2 - 1 + extra) As Byte
        Dim i As Integer
        For i = 0 To array.Length - 1
            narray(2 * i) = array(i)
            narray(2 * i + 1) = &H0
        Next
        For i = 1 To extra
            narray(narray.Length - i) = &H0
        Next
        Return narray
    End Function
    Public Function HPacket(ByVal comm As Integer, ByVal b1() As Byte, ByVal b2() As Byte, Optional ByVal b3() As Byte = Nothing) As Byte()
        Dim tot As Integer
        If b2 Is Nothing Then
            tot = b1.Length + 40
        Else
            tot = b1.Length + b2.Length + 40
        End If
        If Not b3 Is Nothing Then
            tot = tot + b3.Length
        End If
        Dim x As Integer
        tot = tot + 8
        tot = (tot - 16) \ 8
        tot = tot * 8 + 16
        If tot - 16 > 255 Then
            x = tot - 256 - 16
        Else : x = tot - 16
        End If
        Dim h() As Byte = {&H1, &H0, &H0, &H0, &HCE, &HFA, &HB, &HB0, x, (tot - 16) \ 256, &H0, &H0, &H4D, &H4D, &H53, &H20, (tot - 16) \ 8, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, (tot - 32) \ 8, &H0, &H0, &H0, comm, &H0, &H3, &H0}
        Dim pack(tot - 1) As Byte
        Array.ConstrainedCopy(h, 0, pack, 0, 40)
        Array.ConstrainedCopy(b1, 0, pack, 40, b1.Length)
        If Not b2 Is Nothing Then Array.ConstrainedCopy(b2, 0, pack, b1.Length + 40, b2.Length)
        If Not b3 Is Nothing Then Array.ConstrainedCopy(b3, 0, pack, tot - b3.Length, b3.Length)
        s = HexString(pack, pack.Length, 0)
        Return pack
    End Function
    Public Sub TTTest(ByVal sd As Net.Sockets.Socket)
        Dim HB As Byte() = {&H1, &H0, &H0, &H0, &HFF, &HFF, &H1, &H0}
        sd.Send(HPacket(&H1B, HB, Nothing))
    End Sub
End Module
